/**
 * XForm.java
 *
 * Aplicacion Mecano. Enseanza de mecanografia por lecciones
 * para entorno web, multiusuario.
 * Aplicacion web desarrollada segun el paradigam MVC
 * con Struts (http://jakarta.apache.org/struts)
 *
 * Libre distribucion  (ver licencia: license.txt)
 *
 * Autor: Pello Xabier Altadill Izura pello.altadill@terra.com
 * Actualizaciones, documentos, etc: http://ciberia.ya.com/pxai/ma.html
 *
 */

package pxai.struts.mecano.form;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import java.sql.Date;

/**
 * MecanoMecanoForm
 * 
 * Implementa el formulario que se muestra en html 
 * @author   <a href="pello.altadill@terra.com">Pello Xabier Altadill Izura</a>
 * @version 1.0 , date 13/2/02
*/
public final class MecanoMecanoForm extends ActionForm  {


	/**
	* @field Mantenimiento de la accion que estamos procesando (Create or Edit).
	* atributo IMPRESCINDIBLE para STRUS
	*/
    private String action = "Create";

	/**
	* @field login
	*/
    private String login = null;
    
	/**
	* @field codleccion
	*/
    private Integer codleccion = null;

	/**
	* @field flagaprobado
	*/
    private Boolean flagaprobado = null;
     
   	/**
	* @field errores
	*/
    private Integer errores = null;	
     
   	/**
	* @field velocidad
	*/
    private Float velocidad = null;
    
	




	/**
	* Resetea todas las propiedades a sus valores por defecto.
	*
	* @param mapping El mapping utilizado por la instancia.
	* @param request El servlet request que estamos procesando.
	*/
    public void reset(ActionMapping mapping, HttpServletRequest request) {

        this.action = "Create";


    }


	/**
	* Valida las propiedades asignadas desde el HTTP request
	* y devuelve un objeto <code>ActionErrors</code> que encapsula cualquier
	* validacin de error que haya sido encontrada. Si no se han encontrado errores
	* , devuelve <code>null</code> o un objeto <code>ActionErrors</code> sin mensajes
	* de error grabados.
	*
	* @param mapping El mapping utilizado por la instancia.
	* @param request El servlet request que estamos procesando.
	*/
	public ActionErrors validate(ActionMapping mapping,
	                       HttpServletRequest request) {

		ActionErrors errors = new ActionErrors();

		return errors;

	}

	/******************* METODOS de BEAN **********************/

	/**
	* Devuelve la accion.
	*
	* @return String la accion
	*/
    public String getAction() {

		return (this.action);
    }


	/**
	* Establece la accion
	*
	* @param action La nueva accion
	*/
    public void setAction(String action) {

        this.action = action;
    }
    
    	
	public void setLogin(String login) {
		this.login = login; 
	}

	public void setCodleccion(Integer codleccion) {
		this.codleccion = codleccion; 
	}

	public void setFlagaprobado(Boolean flagaprobado) {
		this.flagaprobado = flagaprobado; 
	}

	public void setErrores(Integer errores) {
		this.errores = errores; 
	}

	public void setVelocidad(Float velocidad) {
		this.velocidad = velocidad; 
	}
	public String getLogin() {
		return (this.login); 
	}

	public Integer getCodleccion() {
		return (this.codleccion); 
	}

	public Boolean getFlagaprobado() {
		return (this.flagaprobado); 
	}

	public Integer getErrores() {
		return (this.errores); 
	}

	public Float getVelocidad() {
		return (this.velocidad); 
	}

	/******************* FIN de METODOS de BEAN **********************/

	public String toString() {
		String ret = null;
		ret = "action = " + action + "\n";
		ret += "login = " + login + "\n";
		ret += "codleccion = " + codleccion + "\n";
		ret += "flagaprobado = " + flagaprobado + "\n";
		ret += "errores = " + errores + "\n";
		ret += "velocidad = " + velocidad + "\n";
		return ret;
	}

}//class